<template>
    <app-layout>
        <template #header>Show: {{ show.name }}</template>
        <panel class="px-2">
            <div class="mx-2">
                <div class="font-semibold mt-4 mb-3">Description</div>
                <x-input type="textarea" v-model="description" class="dark:bg-gray-800 w-full p-1 resize-none focus:border rounded" @input="onDescInput" />
                <div class="font-semibold mt-4 mb-2">Type</div>
                <slide-dropdown type="select" :value="tempConfig.type" @input="changeType" :options="configTypes" color="purple">
                    Select a Type
                </slide-dropdown>
                <div v-if="tempConfig.type == 'blank'">
                    <p>
                        There are no settings for a blank show.
                        Blank shows are placeholders and will just give some default content.
                    </p>
                </div>
                <div v-if="tempConfig.type == 'clock'">
                    <p>
                        A simple green clock with a message.<br>
                        Please don't put potentially confusing information on the message.
                    </p>
                    <div class="font-semibold my-2">Message</div>
                    <input type="text" class='dark:bg-gray-800 w-full rounded px-2 py-1' v-model="tempConfig.clock.content" @input="edit"/>
                </div>
                <div v-else-if="tempConfig.type == 'single'">
                    <p class="mb-3">
                        A single show only shows one file.
                        Singles cannot link to other shows, but other carousels or grids can connect to it.
                        Useful for if you want someone else to include your file or you just want to show one file.
                    </p>
                    <item-configurator @change="updateSingle" :config="tempConfig.single" :filenames="Array.isArray(filenames)?{}:filenames" />
                </div>
                <div v-else-if="tempConfig.type == 'grid'">
                    <p>
                        Grid shows will arrange files and other shows in a grid pattern.
                        It is best to limit the number of items to 4. 
                        If you have more than 16 items, scrolling will be enabled.
                    </p>
                </div>
                <div v-else-if="tempConfig.type == 'carousel'">
                    <p>
                        Carousels can handle an infinite number of files and shows (though your viewers won't).
                    </p>
                    <div class="font-semibold mt-4 mb-2">Shape</div>
                    <slide-dropdown type="select" :options="carouselTypes" :value="tempConfig.carousel.shape" @input="(val)=>updateConfig('carousel','shape',val)" color="blue">
                        Carousel Types
                    </slide-dropdown>
                </div>
                <div v-if="tempConfig.type == 'carousel' || tempConfig.type == 'grid'">
                    <div class="block lg:flex lg:items-center lg:w-auto w-full mb-2">
                        <h3 class="text-lg font-bold lg:flex-grow">Show Items</h3>
                        <button class="bg-green-500 border rounded text-white px-4 py-2 border-green-600 hover:border-transparent" @click="addItem(0)">Add Item</button>
                    </div>
                    <div class="relative" v-for="(item,i) in tempConfig.items" :key="item.id">
                        <item-configurator @change="val=>updateItem(i,val)" :config="item" :title="true" :filenames="Array.isArray(filenames)?{}:filenames" :dependent="true" class="my-1" />
                        <a class="my-1 text-green-600" @click="addItem(i+1)" title="Add Item Here"><feather type="plus" /></a>
                        <a class="absolute right-0 top-0 m-2 transition-opacity duration-200 hover:opacity-100 opacity-50 text-red-600" @click="removeItem(i)"><feather type="minus" /></a>
                    </div>
                </div>
                <div class="font-semibold mt-4 mb-2">Displays</div>
                <slide-dropdown :disabled="edited||saving" value="" :options="displayOptions" @input="deploy" color="blue" :title="(edited||saving)? 'Please save to deploy':'Deploy a show to a display'"> <!--  v-if="tempConfig.ready === true" -->
                    Deploy
                </slide-dropdown>
                <ol class="list-none ml-6">
                    <li v-for="(display,index) in deployed" :key="index" >
                        <feather class="h-3 text-blue-500" type="monitor" /> <inertia-link :href="'/displays/' + display.id">{{display.name}}</inertia-link> <feather class="h-3 text-red-600" type="x-square" @click="undeploy(display.id)" title="Remove Display from Show" />
                    </li>
                </ol>
                <!-- TODO: Schedule -->
                <button class="bg-green-500 hover:bg-green-400 rounded px-2 my-2 transform transition-color ease-in-out duration-300"  @click="save" ref="savebtn">
                    {{ saveBtnText }}
                    <fa-icon icon="spinner" class="animate-spin" v-if="saving" />
                    <fa-icon icon="check" v-if="doneSaving" />
                </button>
            </div>
        </panel>
    </app-layout>
</template>

<script>
    import FilePicker from './../../Components/FilePicker'
    import ItemConfigurator from './../../Components/ItemConfigurator'
    import Vue from 'vue'
    import { isEqual, cloneDeep } from 'lodash'

    export default {
        components: {
            FilePicker,
            ItemConfigurator,
        },
        props: {
            show: Object,
            displays: Array,
            filenames: [Array,Object],
            deployed: Array,
        },
        data(){
            const tempConfig = cloneDeep(this.show.config);
            let i = 0;
            if(tempConfig.items) tempConfig.items.forEach(item=>{
                item.id = i++;
            });

            return {
                edited: false,
                title: this.show.title,
                description: this.show.description,
                saving: false,
                doneSaving: true,
                tempConfig,
                itemId: 0,
                configTypes: [
                    {
                        label: 'Clock (Nothing)',
                        value: 'clock',
                        feather: 'clock',
                    },
                    {
                        label: 'Single',
                        value: 'single',
                        feather: 'square',
                    },
                    {
                        label: 'Grid',
                        value: 'grid',
                        feather: 'grid',
                    },
                    {
                        label: 'Carousel',
                        value: 'carousel',
                        image: '/carousel.svg',
                    },
                ],
                carouselTypes: [
                    {
                        label: 'Slider',
                        value: 'square',
                        feather: 'square',
                    },
                    {
                        label: '3D Polygon',
                        value: 'hexagon',
                        feather: 'hexagon',
                    },
                    {
                        label: 'Half-size preview w/ fullscreen view',
                        value: 'circle',
                        feather: 'circle',
                    },
                ],
            };
        },
        computed: {
            displayOptions(){
                const displays = [];
                const deployedIds = this.deployed.map(d => d.id);
                this.displays.forEach((display) => {
                    // Skip deployed ID's
                    if(!(display.id in deployedIds)) {
                        displays.push({
                            value: display.id,
                            label: display.name,
                            feather: 'monitor',
                        });
                    }
                });
                return displays;
            },
            saveBtnText(){
                if(this.edited) return "Save";
                if(this.saving) return "Saving";
                if(this.doneSaving) return "Saved";
                return "Save";
            },
        },
        methods: {
            onDescInput(evt){
                this.edit();

                //this.description = evt.target.innerText;

                //evt.target.style.height = "auto";
                //evt.target.style.height = `${event.target.scrollHeight}px`;
            },
            changeType(type) {
                const typeDefaults = {
                    clock: {
                        content: 'No Content is on this show',
                    },
                    single: {
                        path: null,
                        format: '',
                    },
                    grid: {},
                    carousel: {
                        shape: 'hexagon',
                    },
                };

                if(type != this.tempConfig.type){
                    this.edit();

                    
                    if(!(type in this.tempConfig)) {
                        console.log("Scaffolding show for " + type);
                        this.tempConfig[type] = typeDefaults[type];
                        console.log("config:",this.tempConfig);
                    }
                    this.tempConfig.type = type;
                }
            },
            updateConfig(type, key, value){
                this.edit();

                Vue.set(this.tempConfig[type],key, value);
            },
            updateSingle(config){
                this.edit();
                Vue.set(this.tempConfig, 'single', config);
            },
            addItem(index){
                if(!('items' in this.tempConfig)) Vue.set(this.tempConfig, 'items', []);
                nextId = 0;
                this.tempConfig.items.forEach(item=>{
                    if(item.id > nextId) nextId = item.id + 1;
                });
                this.tempConfig.items.splice(index,0,{
                    id: nextId,
                    path: '',
                    format: '',
                });
            },
            updateItem(index,item){
                this.edit();
                Vue.set(this.tempConfig.items,index,item);
            },
            removeItem(index){
                this.tempConfig.items.splice(index,1);
            },
            save(){
                if(this.edited === false) {
                    this.$refs.savebtn.blur();
                    return;
                }
                const data = {};
                // TODO: Title editable
                if(this.show.title != this.title) data.title = this.title;
                if(this.show.description != this.description) data.description = this.description;
                //if(!isEqual(this.show.config, this.tempConfig)){ // need to fix references somehow
                    data.config = this.tempConfig;
                //}
                this.edited = false;
                this.saving = true;
                const url = '/shows/' + this.show.id.toString();
                console.log("About to initiate inertia to",url,"using data",data);
                this.$inertia.put(url, data, {
                    preserveState: true,
                    preserveScroll: true,
                    only: ['show'],
                    onSuccess: this.saveDone,
                });
                
            },
            saveDone(page){
                this.saving = false;
                this.doneSaving = true;
                this.$refs.savebtn.blur();
            },
            deploy(displayId){
                if(this.edited||this.saving) {
                    alert("Please save show before deploying");
                    return;
                }
                this.$inertia.post('/shows/' + this.show.id + '/display/' + displayId, {},{
                    preserveScroll: true,
                    only:['displays'],
                });
            },
            undeploy(displayId){
                this.$inertia.delete('/shows/' + this.show.id + '/display/' + displayId, {
                    preserveScroll: true,
                    only:['displays'],
                });
            },
            edit(){
                this.edited = true;
                this.doneSaving = false;
            },
        },
        watch:{
            tempConfig(){
                this.edit();
            },
        },
    }
</script>
